#! /usr/bin/env python3
# -*- coding: utf-8 -*-

try:
    unicode('')
except NameError:
    unicode = str

import os, sys, argparse
from subprocess import *

try:
  import matplotlib
  import matplotlib.pyplot as plt
  graphics = True
except:
  graphics = False

def read(filename):
    with open(os.path.join(filename)) as f:
        i_stride = []
        t_stride = []
        for line in f:
            l = line.split()
            if len(l) != 2:
                break;
            i_stride.append(int(l[0]))
            t_stride.append(float(l[1]))
    return (i_stride, t_stride)

display = True

def plot(t, ax):
  i_stride, t_stride = read("res_" + t + ".txt")
  ax.plot(i_stride, t_stride, 'o-', label=t)

def plot2(t, ax):
  i_stride, t_stride = read("res_" + t + ".txt")
  xref = t_stride[0]
  e_stride = [x/xref for x in t_stride] 
  ax.plot(i_stride, e_stride, 'o-', label=t)

if graphics:
  fig, ax = plt.subplots(2, 1, figsize=(10,10))
  ax[1].set_yscale('log')
  ax[1].set_xlabel('Stride')
  ax[1].set_ylabel('Time (s)')
  ax[1].grid()

  plot('doubles', ax[1])
  plot('floats', ax[1])
  plot('ints', ax[1])

  ax[1].legend(['double','float','int'])

  ax[0].set_ylabel('Time / Time(stride=1, float)')
  ax[0].grid()

  plot2('doubles', ax[0])
  plot2('floats', ax[0])
  plot2('ints', ax[0])

  ax[0].legend(['double','float','int'])

  plt.savefig("Offset_stride.pdf")

  if display:
    plt.show()
  else:
    plt.ioff()

