#! /usr/bin/env python
# -*- coding: utf-8 -*-

try:
    unicode('')
except NameError:
    unicode = str

import os, sys, argparse, time
from subprocess import *

parser = argparse.ArgumentParser()
parser.add_argument('-n', type=int, default=4)
parser.add_argument('-m', type=int, default=10)
args = parser.parse_args()

baseDir = os.path.dirname(os.path.realpath(__file__))
installDir = os.path.join(baseDir, 'install')

job = '''#!/bin/bash

#SBATCH --job-name=coalescence
#SBATCH --output=output.txt
#SBATCH --error=output.txt
#SBATCH --partition=gpu
#SBATCH --gres=gpu:1
#SBATCH --account=ams301

#SBATCH --time=00:05:00
#SBATCH --ntasks=1

## load modules
module purge
module load cuda
module load gcc
module load cmake

## compilation

python build.py
echo

## execution

./install/coalescence @N@ @M@
echo
python plot.py
echo

'''

job = job.replace('@N@', str(args.n))
job = job.replace('@M@', str(args.m))

jobFile = 'job.sh'

with open(jobFile, 'w') as f:
  f.write(job)

call(['sbatch', jobFile])
os.unlink(jobFile)

