#! /usr/bin/env python
# -*- coding: utf-8 -*-

try:
    unicode('')
except NameError:
    unicode = str

import os, sys, argparse, numpy, time
from subprocess import *

parser = argparse.ArgumentParser()
parser.add_argument('--factor', '-f', type=float, default=0.99)
args = parser.parse_args()

baseDir = os.path.dirname(os.path.realpath(__file__))
installDir = os.path.join(baseDir, 'install')

user = os.environ['USER']

job = '''#!/bin/bash

#SBATCH --job-name=exemple_large
#SBATCH --output=output.txt
#SBATCH --error=output.txt
#SBATCH --partition=gpu
#SBATCH --gres=gpu:1
#SBATCH --account=ams301

#SBATCH --time=00:05:00
#SBATCH --ntasks=1

## load modules
module purge
module load cuda
#module load gcc
module load cmake

## execution

export FACTOR=@FACTOR@
nvidia-smi

echo
./build.py
echo
./install/exemple_large
echo
'''

job = job.replace('@FACTOR@', str(args.factor))
with open('job.sh', 'w') as f:
  f.write(job)

call(['sbatch', 'job.sh'])
